;; Sawfish theme file
;; created by GimpMill, with manual tweaking

(require 'make-theme)

(let*
   (
      (font (get-font "-freefont-dragonwick-normal-r-normal-*-*-130-*-*-p-*-iso8859-1"))
      (title-width
	 (lambda (w)
	    (let
	       ((w-width (car (window-dimensions w))))
	       (max 0 (+ 20 (min (- w-width 20) (/ (* 4 (text-width (window-name w) font)) 3)))))))
      
      (fix-frame-attrs
	 (lambda (w)
	    (if (eq (window-get w 'current-frame-style) 'Brittany)
	       (rebuild-frame w))))

      (frame-shade-style
	 (lambda (w)
	    (if (eq (window-get w 'current-frame-style) 'Brittany)
	       (set-frame-for-window w t 'shaped)
	       )))

      (frame-unfocus-style
	 (lambda (w)
	    (if
	       (and (eq (window-get w 'current-frame-style) 'Brittany)
		  (eq (window-type w) 'focused)
		  (not (window-get w 'shaded))
		  )
	       (set-frame-for-window w t 'default)
	       )))

      (frame-focus-style
	 (lambda (w)
	    (if
	       (and (eq (window-get w 'current-frame-style) 'Brittany)
		  (or
		     (eq (window-type w) 'default)
		     (eq (window-type w) 'normal)
		     )
		  (not (window-get w 'shaded))
		  )
	       (set-frame-for-window w t 'focused)
	       )))

      (patterns-alist
	 '(
	     ("Border-topleft" ;; 2 x 3
		(inactive "Border-topleft.png")
		(focused "Border-topleft.png")
		(highlighted "Border-topleft.png")
		(clicked "Border-topleft.png")
		)
	     ("Border-top" ;; 286 x 3
		(inactive "Border-top.png")
		(focused "Border-top.png")
		(highlighted "Border-top.png")
		(clicked "Border-top.png")
		)
	     ("Border-topright" ;; 2 x 3
		(inactive "Border-topright.png")
		(focused "Border-topright.png")
		(highlighted "Border-topright.png")
		(clicked "Border-topright.png")
		)
	     ("Border-right" ;; 2 x 187
		(inactive "Border-right.png")
		(focused "Border-right.png")
		(highlighted "Border-right.png")
		(clicked "Border-right.png")
		)
	     ("Border-bottomright" ;; 2 x 3
		(inactive "Border-bottomright.png")
		(focused "Border-bottomright.png")
		(highlighted "Border-bottomright.png")
		(clicked "Border-bottomright.png")
		)
	     ("Border-bottom" ;; 286 x 3
		(inactive "Border-bottom.png")
		(focused "Border-bottom.png")
		(highlighted "Border-bottom.png")
		(clicked "Border-bottom.png")
		)
	     ("Border-bottomleft" ;; 2 x 3
		(inactive "Border-bottomleft.png")
		(focused "Border-bottomleft.png")
		(highlighted "Border-bottomleft.png")
		(clicked "Border-bottomleft.png")
		)
	     ("Border-left" ;; 2 x 187
		(inactive "Border-left.png")
		(focused "Border-left.png")
		(highlighted "Border-left.png")
		(clicked "Border-left.png")
		)
	     
	     ("Binky" ;; 45 x 34
		(focused "Binky.png")
		(highlighted "Binky.png")
		(clicked "Binky.png")
		(inactive "Binky.png")
		)
	     ("Tape0" ;; 21 x 46
		(focused "Tape0.png")
		(highlighted "Tape0.png")
		(clicked "Tape0.png")
		(inactive "Tape0.png")
		)
	     ("Tape1" ;; 20 x 14
		(focused "Tape1.png")
		(highlighted "Tape1.png")
		(clicked "Tape1.png")
		(inactive "Tape1.png")
		)
	     ("Tape2" ;; 19 x 12
		(focused "Tape2.png")
		(highlighted "Tape2.png")
		(clicked "Tape2.png")
		(inactive "Tape2.png")
		)
	     ("Title" ;; 141 x 47
		(focused "Title.png")
		(highlighted "Title.png")
		(clicked "Title.png")
		(inactive "Title.png")
		)
	     
	     ("noBinky" ;; 45 x 34
		(focused "noBinky.png")
		(highlighted "noBinky.png")
		(clicked "noBinky.png")
		(inactive "noBinky.png")
		)
	     ("noTape0" ;; 21 x 46
		(focused "noTape0.png")
		(highlighted "noTape0.png")
		(clicked "noTape0.png")
		(inactive "noTape0.png")
		)
	     ("noTape1" ;; 20 x 14
		(focused "noTape1.png")
		(highlighted "noTape1.png")
		(clicked "noTape1.png")
		(inactive "noTape1.png")
		)
	     ("noTape2" ;; 19 x 12
		(focused "noTape2.png")
		(highlighted "noTape2.png")
		(clicked "noTape2.png")
		(inactive "noTape2.png")
		)
	     ("noTitle" ;; 141 x 47
		(focused "noTitle.png")
		(highlighted "noTitle.png")
		(clicked "noTitle.png")
		(inactive "noTitle.png")
		)
	     )
	 )
      (frames-alist
	 `(
	     ("focused"
		(
		   (background . "Border-topleft")
		   (left-edge . -2)
		   (top-edge . -3)
		   (class . top-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-top")
		   (left-edge . 0)
		   (right-edge . 0)
		   (top-edge . -3)
		   (class . top-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-topright")
		   (right-edge . -2)
		   (top-edge . -3)
		   (class . top-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-right")
		   (right-edge . -2)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . right-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomright")
		   (right-edge . -2)
		   (bottom-edge . -3)
		   (class . bottom-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottom")
		   (left-edge . 0)
		   (right-edge . 0)
		   (bottom-edge . -3)
		   (class . bottom-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomleft")
		   (left-edge . -2)
		   (bottom-edge . -3)
		   (class . bottom-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-left")
		   (left-edge . -2)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . left-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Tape0")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . close-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Tape1")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . maximize-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Tape2")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . iconify-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Title")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . title)
		   (text . window-name)
		   (font . ,font)
		   (x-justify . center)
		   (y-justify . center)
		   (foreground . "#000000")
		   )
		(
		   (background . "Binky")
		   (left-edge . -26)
		   (top-edge . -31)
		   (class . menu-button)
		   )
		)
	     ("normal"
		(
		   (background . "Border-topleft")
		   (left-edge . -2)
		   (top-edge . -3)
		   (class . top-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-top")
		   (left-edge . 0)
		   (right-edge . 0)
		   (top-edge . -3)
		   (class . top-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-topright")
		   (right-edge . -2)
		   (top-edge . -3)
		   (class . top-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-right")
		   (right-edge . -2)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . right-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomright")
		   (right-edge . -2)
		   (bottom-edge . -3)
		   (class . bottom-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottom")
		   (left-edge . 0)
		   (right-edge . 0)
		   (bottom-edge . -3)
		   (class . bottom-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomleft")
		   (left-edge . -2)
		   (bottom-edge . -3)
		   (class . bottom-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-left")
		   (left-edge . -2)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . left-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "noTape0")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . close-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "noTape1")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . maximize-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "noTape2")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . iconify-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "noTitle")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . title)
		   (text . window-name)
		   (font . ,font)
		   (x-justify . center)
		   (y-justify . center)
		   (foreground . "#000000")
		   )
		(
		   (background . "noBinky")
		   (left-edge . -26)
		   (top-edge . -31)
		   (class . menu-button)
		   )
		)
	     ("shaped"
		(
		   (background . "Tape0")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . close-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Tape1")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . maximize-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Tape2")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . iconify-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Title")
		   (left-edge . 7)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -42)
		   (class . title)
		   (text . window-name)
		   (font . ,font)
		   (x-justify . center)
		   (y-justify . center)
		   (foreground . "#000000")
		   )
		(
		   (background . "noBinky")
		   (left-edge . -26)
		   (top-edge . -31)
		   (class . menu-button)
		   )
		)
	     ("transient"
		(
		   (background . "Border-topleft")
		   (left-edge . -2)
		   (top-edge . -3)
		   (class . top-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-top")
		   (left-edge . 0)
		   (right-edge . 0)
		   (top-edge . -3)
		   (class . top-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-topright")
		   (right-edge . -2)
		   (top-edge . -3)
		   (class . top-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-right")
		   (right-edge . -2)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . right-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomright")
		   (right-edge . -2)
		   (bottom-edge . -3)
		   (class . bottom-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottom")
		   (left-edge . 0)
		   (right-edge . 0)
		   (bottom-edge . -3)
		   (class . bottom-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomleft")
		   (left-edge . -2)
		   (bottom-edge . -3)
		   (class . bottom-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-left")
		   (left-edge . -2)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . left-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		)
	     ("shaped-transient"
		)
	     ("unframed"
		)
	     )
	 )
      (mapping-alist
	 '(
	     (default . "normal")
	     (transient . "transient")
	     (shaped . "shaped")
	     (shaped-transient . "shaped-transient")
	     (unframed . "nil")
	     (focused . "focused")
	     )
	 )
      
      (theme-name 'Brittany)
      )
   
   (add-frame-style theme-name 
      (make-theme patterns-alist frames-alist mapping-alist)
      )

   (when 
      (boundp 'mark-frame-style-editable)
      (mark-frame-style-editable theme-name)
      )

   (call-after-property-changed 'WM_NAME fix-frame-attrs)
   
   (add-hook 'focus-in-hook frame-focus-style t)
   (add-hook 'focus-out-hook frame-unfocus-style t)
   (add-hook 'shade-window-hook frame-shade-style)
   )
